<template>
  <div class="sa-grid">
    <template v-for="(item, index) of children">
      <sa-grid-item :key="index" :item="item" class="item" />
    </template>
  </div>
</template>

<script>
import SaGridItem from './SaGridItem'
export default {
  name: 'SaGrid',
  components: { SaGridItem },
  computed: {
    children() {
      // filter out empty child elements
      return this.$slots.default?.filter(({ tag }) => tag)
    }
  }
}
</script>

<style lang="scss" scoped>
.sa-grid {
  margin: -#{spacing(1)};
  display: flex;
  flex-wrap: wrap;
  flex-direction: row;
  .item {
    padding: spacing(1);
    flex: 0 0 100%;
    @include breakpoint(small) {
      flex-basis: 50%;
    }
    @include breakpoint(medium) {
      flex-basis: 33.33%;
    }
    @include breakpoint(large) {
      flex-basis: 25%;
    }
    @include breakpoint(xlarge) {
      flex-basis: 16.66%;
    }
    &::v-deep > * {
      height: 100%;
    }
  }
}
</style>
